/*
  Keyboard function keys

  For the Arduino Leonardo and Micro.

  8 keys are implemented, Shift and Ctrl key with hold function
  
 */

//#include "Keyboard.h"
#include <HID-Project.h>
//#include "Keypad_mod.h"

//  2  4  A3  A2
//  3  5  A0  A1

#define KEY_WIN_RIGHT 5
#define KEY_WIN_LEFT  3
#define KEY_SHIFT     A0
#define KEY_CTRL      A1
#define KEY_MUTE      2
#define KEY_PLAY      A3
#define KEY_BACK      4
#define KEY_FORW      A2

void setup() {
  // make the pushButton pin an input:
  pinMode(KEY_WIN_RIGHT, INPUT_PULLUP);
  pinMode(KEY_WIN_LEFT,  INPUT_PULLUP);
  pinMode(KEY_SHIFT,     INPUT_PULLUP);
  pinMode(KEY_CTRL,      INPUT_PULLUP);
  pinMode(KEY_MUTE,      INPUT_PULLUP);
  pinMode(KEY_PLAY,      INPUT_PULLUP);
  pinMode(KEY_BACK,      INPUT_PULLUP);
  pinMode(KEY_FORW,      INPUT_PULLUP);
  // initialize control over the keyboard:
  Keyboard.begin();
  Consumer.begin();
}

void loop() {
  // special handling because long press
  if (!digitalRead(KEY_SHIFT))
  {
    Keyboard.press(KEY_RIGHT_SHIFT);
    while (!digitalRead(KEY_SHIFT)) delay(100);
    Keyboard.releaseAll();
    delay(100) ;
  }
  else if (!digitalRead(KEY_CTRL))
  {
    Keyboard.press(KEY_RIGHT_CTRL);
    while (!digitalRead(KEY_CTRL)) delay(100);
    Keyboard.releaseAll();
    delay(100) ;
  }
  // single pulse keys
  else if (!digitalRead(KEY_WIN_RIGHT))
  {
    Keyboard.press(KEY_LEFT_GUI);
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_RIGHT_ARROW);
    delay(100) ;
    Keyboard.releaseAll();
    while (!digitalRead(KEY_WIN_RIGHT)) delay(100);
  } 
  else if (!digitalRead(KEY_WIN_LEFT))
  {
    Keyboard.press(KEY_RIGHT_GUI);
    Keyboard.press(KEY_LEFT_SHIFT);
    Keyboard.press(KEY_LEFT_ARROW);
    delay(100) ;
    Keyboard.releaseAll();
    while (!digitalRead(KEY_WIN_LEFT)) delay(100);
  }
  else if (!digitalRead(KEY_MUTE))
  {
    Consumer.write(MEDIA_VOL_MUTE);
    delay(100) ;
    Keyboard.releaseAll();
    while (!digitalRead(KEY_MUTE)) delay(100);
  }
  else if (!digitalRead(KEY_PLAY))
  {
    Consumer.write(MEDIA_PLAY_PAUSE);
    delay(100) ;
    Keyboard.releaseAll();
    while (!digitalRead(KEY_PLAY)) delay(100);
  }
  else if (!digitalRead(KEY_BACK))
  {
    Consumer.write(MEDIA_PREV);
    delay(100) ;
    Keyboard.releaseAll();
    while (!digitalRead(KEY_BACK)) delay(100);
  }
  else if (!digitalRead(KEY_FORW))
  {
    Consumer.write(MEDIA_NEXT);
    delay(100) ;
    Keyboard.releaseAll();
    while (!digitalRead(KEY_FORW)) delay(100);
  }
}
